Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 1 | """ |
| 2 | Copyright 2018-present Open Networking Foundation |
| 3 | |
| 4 | Licensed under the Apache License, Version 2.0 (the "License"); |
| 5 | you may not use this file except in compliance with the License. |
| 6 | You may obtain a copy of the License at |
| 7 | |
| 8 | http://www.apache.org/licenses/LICENSE-2.0 |
| 9 | |
| 10 | Unless required by applicable law or agreed to in writing, software |
| 11 | distributed under the License is distributed on an "AS IS" BASIS, |
| 12 | WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 13 | See the License for the specific language governing permissions and |
| 14 | limitations under the License. |
| 15 | """ |
| 16 | |
| 17 | """ |
| 18 | Rules to build the ONOS GUI 2 |
| 19 | |
Sean Condon | 0c577f6 | 2018-11-18 22:40:05 +0000 | [diff] [blame] | 20 | The GUI2 Angular 7 elements are built here with Angular CLI 'ng' |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 21 | Some work is being done in the Bazel community to integrate Bazel and |
Sean Condon | 0c577f6 | 2018-11-18 22:40:05 +0000 | [diff] [blame] | 22 | Angular 7, (Angular Buildtools Convergence - |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 23 | https://docs.google.com/document/d/1OlyiUnoTirUj4gecGxJeZBcjHcFr36RvLsvpBl2mxA8/preview) |
| 24 | but it is in the very early stages (Aug'18) and not yet fit |
| 25 | for production and at present it works as a replacement for Angular CLI |
| 26 | (which is not desirable). |
| 27 | |
| 28 | There are plans to extend Bazel it to work with Angular CLI, and if works |
| 29 | well this Bazel file may be rearchiteced in future. |
| 30 | |
| 31 | Bazel and npm are incompatibe in how they deal with files. npm likes to |
| 32 | follow links to get back to the original canonical path names, and bazel |
| 33 | uses links extensively when populating the sandbox. To get around these |
| 34 | problems, the rules that follow use filegroups to specify the files as |
| 35 | dependencies and then use a genrule to convert the files into a tar ball. |
| 36 | Once the tar ball is unrolled into the sandbox, the links are broken, but |
| 37 | the build is still hermetic since those files are referred to as dependencies in the genrule. |
| 38 | """ |
| 39 | |
Carmelo Cascone | d33d3b4 | 2019-06-18 12:12:36 -0700 | [diff] [blame] | 40 | load("//tools/build/bazel:jdk_genrule.bzl", genrule = "jdk_genrule") |
| 41 | |
Sean Condon | b2c483c | 2019-01-16 20:28:55 +0000 | [diff] [blame] | 42 | COMPILE_DEPS = CORE_DEPS + JACKSON + KRYO + CLI + [ |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 43 | "@javax_ws_rs_api//jar", |
| 44 | "@servlet_api//jar", |
| 45 | "@jetty_websocket//jar", |
Sean Condon | b2c483c | 2019-01-16 20:28:55 +0000 | [diff] [blame] | 46 | "@jetty_websocket_api//jar", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 47 | "@jetty_util//jar", |
| 48 | "@jersey_media_multipart//jar", |
| 49 | "@jersey_server//jar", |
Ray Milkey | 427e975 | 2018-11-15 16:34:48 -0800 | [diff] [blame] | 50 | "@jersey_hk2//jar", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 51 | "//utils/rest:onlab-rest", |
| 52 | "//core/store/serializers:onos-core-serializers", |
| 53 | ] |
| 54 | |
| 55 | TEST_DEPS = TEST + [ |
| 56 | "//core/api:onos-api-tests", |
| 57 | "//drivers/default:onos-drivers-default", |
| 58 | ] |
| 59 | |
| 60 | """ |
| 61 | Files that get put at the top level of the tar ball |
| 62 | """ |
| 63 | |
| 64 | filegroup( |
| 65 | name = "_root_level_files", |
| 66 | srcs = |
| 67 | [ |
| 68 | ":angular.json", |
| 69 | ":karma.conf.js", |
| 70 | ":package.json", |
| 71 | ":package-lock.json", |
| 72 | ":protractor.conf.js", |
| 73 | ":src/main/tsconfig.json", |
| 74 | ":src/main/tslint.json", |
| 75 | ":tsconfig.json", |
| 76 | ], |
| 77 | ) |
| 78 | |
| 79 | filegroup( |
| 80 | name = "_e2e_test_files", |
| 81 | srcs = [ |
| 82 | ":e2e/app.e2e-spec.ts", |
| 83 | ":e2e/app.po.ts", |
| 84 | ":e2e/tsconfig.e2e.json", |
| 85 | ], |
| 86 | ) |
| 87 | |
| 88 | """ |
| 89 | Files that get put into the WEB-INF directory of the tar ball |
| 90 | """ |
| 91 | |
| 92 | filegroup( |
| 93 | name = "_web_inf_classes_files", |
| 94 | srcs = |
| 95 | [ |
| 96 | ":src/main/webapp/error.html", |
| 97 | ":src/main/webapp/login.html", |
| 98 | ":src/main/webapp/nav.html", |
| 99 | ":src/main/webapp/not-ready.html", |
Sean Condon | 55c3053 | 2018-10-29 12:26:57 +0000 | [diff] [blame] | 100 | ":src/main/webapp/onos.global.css", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 101 | ], |
| 102 | ) |
| 103 | |
| 104 | """ |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 105 | Run ng build to create outputs in production mode |
| 106 | See bazel-genfiles/web/gui2/onos-gui2-ng-build-prod.log for details of the Angular CLI output |
Sean Condon | 5ca0026 | 2018-09-06 17:55:25 +0100 | [diff] [blame] | 107 | |
| 108 | To avoid the overhead of having several "npm install" invocations, we just do |
Sean Condon | 0c577f6 | 2018-11-18 22:40:05 +0000 | [diff] [blame] | 109 | it once in the //web/gui2-fw-lib which is really the core for the whole Angular 7 |
Sean Condon | 5ca0026 | 2018-09-06 17:55:25 +0100 | [diff] [blame] | 110 | structure in ONOS. This copies files in to node_modules, but because the gui2-fw-lib |
| 111 | has not been generated at that time we copy it in separately below with the 'tar' cmd |
| 112 | and then 'mv' |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 113 | """ |
| 114 | |
| 115 | genrule( |
| 116 | name = "_onos-gui2-ng-build", |
| 117 | srcs = [ |
| 118 | "@nodejs//:bin/npm", |
| 119 | "@nodejs//:bin/node", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 120 | "@nodejs//:bin/nodejs/bin/node", |
| 121 | "@nodejs//:bin/nodejs/bin/npm", |
Sean Condon | 5ca0026 | 2018-09-06 17:55:25 +0100 | [diff] [blame] | 122 | "//web/gui2-fw-lib:onos-gui2-fw-npm-install", |
| 123 | "//web/gui2-fw-lib:onos-gui2-fw-ng-build", |
| 124 | "//web/gui2-fw-lib:gui2_fw_lib_ext_css", |
Sean Condon | ff85fbe | 2019-03-16 14:28:46 +0000 | [diff] [blame] | 125 | "//web/gui2-topo-lib:gui2-topo-lib-build", |
Sean Condon | 87b7850 | 2018-09-17 20:53:24 +0100 | [diff] [blame] | 126 | "//apps/faultmanagement/fm-gui2-lib:fm-gui2-lib-build", |
Sean Condon | 5ca0026 | 2018-09-06 17:55:25 +0100 | [diff] [blame] | 127 | ":_root_level_files", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 128 | ":_web_app_all", |
Boyuan Yan | 6b23b38 | 2019-06-04 11:59:35 -0700 | [diff] [blame] | 129 | "//apps/roadm/web/roadm-gui:roadm-gui-lib-build", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 130 | ], |
| 131 | outs = [ |
| 132 | "onos-gui2-ng-build-prod.log", |
| 133 | "onos-gui2-ng-build.jar", |
| 134 | ], |
| 135 | cmd = "ROOT=`pwd` &&" + |
| 136 | " export HOME=. &&" + |
| 137 | " export XDG_CONFIG_HOME=$(@D)/config &&" + |
| 138 | " NODE=$(location @nodejs//:bin/node) &&" + |
Sean Condon | 5ca0026 | 2018-09-06 17:55:25 +0100 | [diff] [blame] | 139 | " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created |
| 140 | " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 141 | " mkdir -p web/gui2 && cd web/gui2 &&" + |
| 142 | " jar xf ../../$(location :_web_app_all) &&" + |
| 143 | " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" + |
Sean Condon | 5ca0026 | 2018-09-06 17:55:25 +0100 | [diff] [blame] | 144 | " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" + |
| 145 | " mv package/ node_modules/gui2-fw-lib/ &&" + |
Sean Condon | 87b7850 | 2018-09-17 20:53:24 +0100 | [diff] [blame] | 146 | # Add in modules from external packages |
Sean Condon | ff85fbe | 2019-03-16 14:28:46 +0000 | [diff] [blame] | 147 | " GUI2_TOPO_LIB_FILES=($(locations //web/gui2-topo-lib:gui2-topo-lib-build)) &&" + # An array of filenames - sorted by time created |
| 148 | " tar xf $$ROOT/$${GUI2_TOPO_LIB_FILES[0]} &&" + |
| 149 | " mv package/ node_modules/gui2-topo-lib/ &&" + |
Sean Condon | 87b7850 | 2018-09-17 20:53:24 +0100 | [diff] [blame] | 150 | " FM_GUI2_LIB_FILES=($(locations //apps/faultmanagement/fm-gui2-lib:fm-gui2-lib-build)) &&" + # An array of filenames - sorted by time created |
| 151 | " tar xf $$ROOT/$${FM_GUI2_LIB_FILES[0]} &&" + |
| 152 | " mv package/ node_modules/fm-gui2-lib/ &&" + |
Boyuan Yan | 6b23b38 | 2019-06-04 11:59:35 -0700 | [diff] [blame] | 153 | " ROADM_GUI_LIB_FILES=($(locations //apps/roadm/web/roadm-gui:roadm-gui-lib-build)) &&" + # An array of filenames - sorted by time created |
| 154 | " tar xf $$ROOT/$${ROADM_GUI_LIB_FILES[0]} &&" + |
| 155 | " mv package/ node_modules/roadm-gui-lib/ &&" + |
Sean Condon | 87b7850 | 2018-09-17 20:53:24 +0100 | [diff] [blame] | 156 | # End of add in modules from external packages |
Sean Condon | 5ca0026 | 2018-09-06 17:55:25 +0100 | [diff] [blame] | 157 | " mkdir -p src/main/webapp/app/fw &&" + |
| 158 | " (cd src/main/webapp/app/fw &&" + |
| 159 | " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" + |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 160 | " chmod +x $$ROOT/web/gui2/node_modules/@angular/cli/bin/ng &&" + |
Thomas Vachuska | 0c19e65 | 2018-08-28 10:57:07 -0700 | [diff] [blame] | 161 | " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/web/gui2/node_modules/@angular/cli/bin:$$PATH &&" + |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 162 | " node -v > ../../$(location onos-gui2-ng-build-prod.log) &&" + |
| 163 | " npm -v >> ../../$(location onos-gui2-ng-build-prod.log) &&" + |
Sean Condon | 0c577f6 | 2018-11-18 22:40:05 +0000 | [diff] [blame] | 164 | " ng version >> ../../$(location onos-gui2-ng-build-prod.log) &&" + |
| 165 | " ng build --extract-css --prod --preserve-symlinks" + |
Sean Condon | bf7ff4f | 2019-03-17 16:18:42 +0000 | [diff] [blame] | 166 | " --base-href /onos/ui/ --deploy-url /onos/ui/ >> $$ROOT/$(location onos-gui2-ng-build-prod.log) 2>&1 ||" + |
Sean Condon | 87b7850 | 2018-09-17 20:53:24 +0100 | [diff] [blame] | 167 | " if [ $$? -eq 0 ]; then echo 'Successfully ran build';" + |
| 168 | " else " + |
| 169 | " echo 'Error running \'ng build\' on \'//web/gui2:_onos-gui2-ng-build\'. \\\n" + |
| 170 | " See bazel-genfiles/web/gui2/onos-gui2-ng-build-prod.log for more details' >&2;" + |
| 171 | #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" + |
| 172 | " exit 1;" + |
| 173 | " fi;" + |
Sean Condon | 95fb574 | 2019-04-02 12:16:55 +0100 | [diff] [blame] | 174 | " cp -r node_modules/gui2-fw-lib/assets src/main/webapp/dist &&" + |
| 175 | " cd src/main/webapp/dist &&" + |
| 176 | " jar Mcf $$ROOT/$(location onos-gui2-ng-build.jar) .", |
Sean Condon | 0c577f6 | 2018-11-18 22:40:05 +0000 | [diff] [blame] | 177 | message = "Angular CLI 7 build", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 178 | ) |
| 179 | |
| 180 | """ |
| 181 | Run 'ng test' to run Angular test and 'ng lint' for checkstyle |
| 182 | See bazel-genfiles/web/gui2/onos-gui2-ng-lint.log or |
| 183 | bazel-genfiles/web/gui2/onos-gui2-ng-test.log for details of the Angular CLI output |
| 184 | """ |
| 185 | |
| 186 | genrule( |
| 187 | name = "_onos-gui2-ng-test-genrule", |
| 188 | srcs = [ |
| 189 | "@nodejs//:bin/npm", |
| 190 | "@nodejs//:bin/node", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 191 | "@nodejs//:bin/nodejs/bin/node", |
| 192 | "@nodejs//:bin/nodejs/bin/npm", |
Sean Condon | 5ca0026 | 2018-09-06 17:55:25 +0100 | [diff] [blame] | 193 | "//web/gui2-fw-lib:onos-gui2-fw-npm-install", |
| 194 | "//web/gui2-fw-lib:onos-gui2-fw-ng-build", |
| 195 | "//web/gui2-fw-lib:gui2_fw_lib_ext_css", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 196 | ":_web_app_all", |
| 197 | ":_web_app_tests", |
| 198 | ":_angular_all", |
| 199 | ], |
| 200 | outs = [ |
| 201 | "onos-gui2-ng-ver.log", |
| 202 | "onos-gui2-ng-lint.log", |
| 203 | "onos-gui2-ng-test.log", |
| 204 | ], |
| 205 | cmd = " ROOT=`pwd` &&" + |
| 206 | " export HOME=. &&" + |
| 207 | " export XDG_CONFIG_HOME=$(@D)/config &&" + |
| 208 | " NODE=$(location @nodejs//:bin/node) &&" + |
Sean Condon | 5ca0026 | 2018-09-06 17:55:25 +0100 | [diff] [blame] | 209 | " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created |
| 210 | " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 211 | " mkdir -p web/gui2 &&" + |
| 212 | " cd web/gui2 &&" + |
| 213 | " jar xf ../../$(location :_angular_all) &&" + |
| 214 | " jar xf ../../$(location :_web_app_all) &&" + |
| 215 | " jar xf ../../$(location :_web_app_tests) &&" + |
| 216 | " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" + |
Sean Condon | 5ca0026 | 2018-09-06 17:55:25 +0100 | [diff] [blame] | 217 | " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" + |
| 218 | " mv package/ node_modules/gui2-fw-lib/ &&" + |
| 219 | " mkdir -p src/main/webapp/app/fw &&" + |
| 220 | " (cd src/main/webapp/app/fw &&" + |
| 221 | " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" + |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 222 | " chmod +x $$ROOT/web/gui2/node_modules/@angular/cli/bin/ng &&" + |
Thomas Vachuska | 0c19e65 | 2018-08-28 10:57:07 -0700 | [diff] [blame] | 223 | " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/web/gui2/node_modules/@angular/cli/bin:$$PATH &&" + |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 224 | " node -v > ../../$(location onos-gui2-ng-ver.log) &&" + |
| 225 | " npm -v >> ../../$(location onos-gui2-ng-ver.log) &&" + |
Sean Condon | 50855cf | 2018-12-23 15:37:42 +0000 | [diff] [blame] | 226 | " ng version >> ../../$(location onos-gui2-ng-ver.log);" + |
| 227 | " ng lint > ../../$(location onos-gui2-ng-lint.log) 2>&1 ||" + |
| 228 | " if [ $$? -eq 0 ]; then echo 'Successfully ran lint';" + |
| 229 | " else " + |
| 230 | " echo 'Error running \'ng lint\' on \'//web/gui2:onos-gui2-ng-test\'. \\\n" + |
| 231 | " See bazel-genfiles/web/gui2/onos-gui2-ng-lint.log for more details' >&2;" + |
| 232 | " exit 1;" + |
| 233 | " fi;" + |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 234 | " if [ -f /usr/bin/chromium-browser ]; then " + # Add to this for Mac and Chrome |
| 235 | " export CHROME_BIN=/usr/bin/chromium-browser; " + |
| 236 | " elif [ -f /opt/google/chrome/chrome ]; then " + |
| 237 | " export CHROME_BIN=/opt/google/chrome/chrome; " + |
| 238 | " else " + |
| 239 | " MSG='Warning: Step onos-gui2-ng-test skipped because \\n" + |
| 240 | " no binary for ChromeHeadless browser was found at /usr/bin/chromium-browser. \\n" + |
| 241 | " Install Google Chrome or Chromium Browser to allow this step to run.';" + |
| 242 | " echo -e $$MSG >&2;" + |
| 243 | " echo -e $$MSG > ../../$(location onos-gui2-ng-test.log);" + |
| 244 | " exit 0;" + |
| 245 | " fi;" + |
| 246 | " ng test --preserve-symlinks --code-coverage --browsers=ChromeHeadless" + |
| 247 | " --watch=false > ../../$(location onos-gui2-ng-test.log) 2>&1 ||" + |
| 248 | " if [ $$? -eq 0 ]; then echo 'Successfully ran tests';" + |
| 249 | " else " + |
| 250 | " echo 'Error running \'ng test\' on \'//web/gui2:onos-gui2-ng-test\'. \\\n" + |
| 251 | " See bazel-genfiles/web/gui2/onos-gui2-ng-test.log for more details' >&2;" + |
| 252 | #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" + |
| 253 | " exit 1;" + |
| 254 | " fi;", |
Sean Condon | 0c577f6 | 2018-11-18 22:40:05 +0000 | [diff] [blame] | 255 | message = "Angular CLI 7 lint and test", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 256 | ) |
| 257 | |
| 258 | """ |
| 259 | Make a jar file of all the webapp files. Useful for breaking symblic links in the sandbox |
| 260 | """ |
| 261 | |
| 262 | genrule( |
| 263 | name = "_web_app_all", |
| 264 | srcs = glob( |
| 265 | [ |
| 266 | "src/main/webapp/**", |
| 267 | ], |
| 268 | exclude = [ |
| 269 | "src/main/webapp/**/*.spec.ts", # Don't track tests here |
| 270 | "src/main/webapp/tests/**", |
| 271 | "src/main/webapp/node_modules/**", |
| 272 | "src/main/webapp/dist/**", |
| 273 | "src/main/webapp/doc/**", |
Sean Condon | 87b7850 | 2018-09-17 20:53:24 +0100 | [diff] [blame] | 274 | "src/main/webapp/app/fw/**", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 275 | ], |
| 276 | ), |
| 277 | outs = ["web_app_all.jar"], |
| 278 | cmd = "cd web/gui2 &&" + |
| 279 | " find src/main/webapp -type f -exec touch -t 201808280000 {} \; &&" + |
| 280 | " jar Mcf ../../$@ src/main/webapp", |
| 281 | ) |
| 282 | |
| 283 | """ |
| 284 | Make a jar file of all the webapp test (*.spec.ts) files. |
| 285 | """ |
| 286 | |
| 287 | genrule( |
| 288 | name = "_web_app_tests", |
| 289 | srcs = glob( |
| 290 | [ |
| 291 | "src/main/webapp/**/*.spec.ts", |
| 292 | ], |
| 293 | exclude = [ |
| 294 | "src/main/webapp/tests/**", |
| 295 | "src/main/webapp/node_modules/**", |
| 296 | "src/main/webapp/dist/**", |
| 297 | "src/main/webapp/doc/**", |
| 298 | ], |
| 299 | ), |
| 300 | outs = ["web_app_tests.jar"], |
| 301 | cmd = "cd web/gui2 &&" + |
| 302 | " find src/main/webapp -type f -exec touch -t 201808280000 {} \; &&" + |
| 303 | " jar Mcf ../../$@ src/main/webapp", |
| 304 | ) |
| 305 | |
| 306 | """ |
| 307 | Make a jar file of all the supporting files. Useful for breaking symblic links in the sandbox |
| 308 | """ |
| 309 | |
| 310 | genrule( |
| 311 | name = "_angular_all", |
| 312 | srcs = [ |
| 313 | ":_e2e_test_files", |
| 314 | ":_root_level_files", |
| 315 | ], |
| 316 | outs = ["angular_all.jar"], |
| 317 | cmd = " cd web/gui2 && jar Mcf ../../$@ .", |
| 318 | ) |
| 319 | |
| 320 | """ |
| 321 | Builds the java jar for the java code provided by the GUI2 |
| 322 | """ |
| 323 | |
| 324 | osgi_jar_with_tests( |
| 325 | name = "_onos-gui2-base-jar", |
Sean Condon | 87b7850 | 2018-09-17 20:53:24 +0100 | [diff] [blame] | 326 | srcs = |
| 327 | glob([ |
| 328 | "src/main/java/**", |
| 329 | ]) + [ |
| 330 | "//web/gui:onos-gui-java-for-gui2", |
| 331 | ], |
Sean Condon | b2c483c | 2019-01-16 20:28:55 +0000 | [diff] [blame] | 332 | exclude_tests = [ |
| 333 | "org.onosproject.ui.impl.AbstractUiImplTest", |
| 334 | "org.onosproject.ui.impl.topo.model.AbstractTopoModelTest", |
| 335 | ], |
| 336 | karaf_command_packages = [ |
| 337 | "org.onosproject.ui.impl.cli", |
| 338 | "org.onosproject.ui.impl.topo", |
| 339 | ], |
Sean Condon | 3c8e558 | 2018-08-28 23:22:43 +0100 | [diff] [blame] | 340 | suppress_checkstyle = True, |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 341 | test_deps = TEST_DEPS, |
Sean Condon | bf7ff4f | 2019-03-17 16:18:42 +0000 | [diff] [blame] | 342 | web_context = "/onos/ui", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 343 | deps = COMPILE_DEPS, |
| 344 | ) |
| 345 | |
| 346 | """ |
| 347 | Builds the tar ball for the ONOS GUI2 |
| 348 | """ |
| 349 | |
| 350 | genrule( |
Sean Condon | bf7ff4f | 2019-03-17 16:18:42 +0000 | [diff] [blame] | 351 | name = "onos-web-gui2", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 352 | srcs = [ |
| 353 | ":_onos-gui2-ng-build", |
| 354 | ":_onos-gui2-base-jar", |
| 355 | ":_web_inf_classes_files", |
Sean Condon | b2c483c | 2019-01-16 20:28:55 +0000 | [diff] [blame] | 356 | "//web/gui:onos-gui-lion-for-gui2", |
Sean Condon | 0d064ec | 2019-02-04 21:53:53 +0000 | [diff] [blame] | 357 | "//web/gui:onos-gui-data-for-gui2", |
Sean Condon | 3c8e558 | 2018-08-28 23:22:43 +0100 | [diff] [blame] | 358 | "src/main/webapp/WEB-INF/web.xml", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 359 | ], |
| 360 | outs = ["onos-gui2.jar"], |
| 361 | cmd = " ROOT=`pwd` &&" + |
| 362 | " mkdir -p web/gui2/WEB-INF/classes &&" + |
| 363 | " cd web/gui2 &&" + |
| 364 | " BUILD_FILES=($(locations :_onos-gui2-ng-build)) &&" + # An array of filenames - sorted by time created |
| 365 | " for i in $(locations :_web_inf_classes_files); do cp $$ROOT/$$i ./WEB-INF/classes/; done &&" + |
| 366 | " (cd WEB-INF/classes && jar xf $$ROOT/$${BUILD_FILES[1]}) &&" + |
| 367 | " jar xf $$ROOT/$(location :_onos-gui2-base-jar) &&" + |
Sean Condon | b2c483c | 2019-01-16 20:28:55 +0000 | [diff] [blame] | 368 | " unzip -q $$ROOT/$(location //web/gui:onos-gui-lion-for-gui2) web/gui/src/main/resources/**/* &&" + |
| 369 | " mv web/gui/src/main/resources/org/onosproject/ui/lion* WEB-INF/classes/org/onosproject/ui/ &&" + |
| 370 | " mv web/gui/src/main/resources/core WEB-INF/classes/ &&" + |
Sean Condon | 0d064ec | 2019-02-04 21:53:53 +0000 | [diff] [blame] | 371 | " unzip -q $$ROOT/$(location //web/gui:onos-gui-data-for-gui2) web/gui/src/main/webapp/data/**/* &&" + |
| 372 | " mv web/gui/src/main/webapp/data WEB-INF/classes/ &&" + |
Sean Condon | 95fb574 | 2019-04-02 12:16:55 +0100 | [diff] [blame] | 373 | " find . -type f -exec touch -t 201903200000 {} \; &&" + |
Sean Condon | b2c483c | 2019-01-16 20:28:55 +0000 | [diff] [blame] | 374 | " jar cmf META-INF/MANIFEST.MF $$ROOT/$@ WEB-INF/web.xml WEB-INF/classes OSGI-INF/*.xml", |
Sean Condon | f6af2a5 | 2018-08-19 10:43:24 +0100 | [diff] [blame] | 375 | output_to_bindir = 1, |
| 376 | visibility = ["//visibility:public"], |
| 377 | ) |
| 378 | |
| 379 | """ |
| 380 | Wrap the genrule for testing in a test |
| 381 | """ |
| 382 | |
| 383 | sh_test( |
| 384 | name = "onos-gui2-ng-tests", |
| 385 | size = "small", |
| 386 | srcs = [ |
| 387 | ":ng-test.sh", |
| 388 | ], |
| 389 | data = [ |
| 390 | ":_onos-gui2-ng-test-genrule", |
| 391 | ], |
| 392 | deps = [ |
| 393 | "@bazel_tools//tools/bash/runfiles", |
| 394 | ], |
| 395 | ) |
Sean Condon | bf7ff4f | 2019-03-17 16:18:42 +0000 | [diff] [blame] | 396 | |
| 397 | onos_app( |
| 398 | category = "Graphical User Interface", |
| 399 | description = "ONOS GUI2 - a reengineered version of the original ONOS GUI " + |
| 400 | "based on the latest Angular framework components", |
| 401 | title = "ONOS GUI2", |
| 402 | url = "http://onosproject.org", |
| 403 | ) |